using System;


namespace _27._11._2.zad
{
    class Program
    {


        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            string[] unosmaks = Console.ReadLine().Split();
            int bro = int.Parse(unosmaks[0]);
            int bra = int.Parse(unosmaks[1]);
            int brb = int.Parse(unosmaks[2]);
            int brab = int.Parse(unosmaks[3]);
            int[] kolicina = new int[n];
            string[] vk = new string[n];
            
            int a = 0;
            int b = 0;
            int o = 0;
            int ab = 0;
            int brko=0;
            int brka = 0;
            int brkb = 0;
            
            for (int i = 0; i < n; i++)
            {
                string[] unos = Console.ReadLine().Split();
                vk[i] = unos[0];
                kolicina[i] = int.Parse(unos[1]);
                if (vk[i] == "A") a = a + kolicina[i];
                else if (vk[i] == "B") b = b + kolicina[i];
                else if (vk[i] == "O") o = o + kolicina[i];
                else if(vk[i]=="AB")ab = ab + kolicina[i];
            }
            int pom = 0;
            if (o > bro)
            {
                
                pom = 1;
            }
            else if(o<=bro) brko = bro - o;
            if (a > bra + brko)pom = 1;           
            else
            {
                if (a <= bra) brka = bra-a;
                else brko = brko - (a - bra);
            }
            if (b > brb + brko)pom = 1;            
            else
            {
                if (b <= brb) brkb =brb-b;
                else brko = brko - (b - brb);
            }
            if (ab > brab + brko + brka + brkb) pom = 1;
            if (pom == 0) { 
  Console.WriteLine("moguce");              
                for (int i = 0; i < n; i++)
                {
                    o = 0;
                    a = 0;
                    b = 0;
                    ab = 0;
                    if (vk[i] == "O")
                    {
                        o = kolicina[i];
                    }
                    else if (vk[i] == "A")
                    {
                        if (kolicina[i] <= bra)
                        {
                            a = kolicina[i];
                            bra = bra - a;
                        }
                        else
                        {
                            a = bra;
                            o = kolicina[i] - a;
                            
                        }
                    }
                    else if (vk[i] == "B")
                    {
                        if (kolicina[i] <= brb)
                        {
                            b = kolicina[i];
                            brb = brb - kolicina[i];

                        }
                        else
                        {
                            b = brb;
                            o = kolicina[i] - b;
                        }
                    }
                    else
                    {
                        if (kolicina[i] <= brab)
                        {
                            ab = kolicina[i];
                            brab = brab - kolicina[i];

                        }
                        else
                        {
                            ab = brab;
                            if (ab + brka >= kolicina[i])
                            {
                                a = kolicina[i] - ab;
                                brka = brka - a;
                                brab = 0;
                            }
                            else if (ab + brka + brkb >= kolicina[i])
                            {
                                a = brka;
                                b = kolicina[i] - ab - a;
                                brkb = brkb - b;
                                brka = 0;
                                brab = 0;
                            }
                            else if (ab + brka + brkb + brko >= kolicina[i])
                            {
                                a = brka;
                                b = brkb;
                                o = kolicina[i] - ab - a - b;
                                brko = brko - o;
                                brkb = 0;
                                brab = 0;
                                brka = 0;

                            }

                        }
                    }
                    Console.WriteLine(o+" "+a+" "+b+" "+ab);
                }
            }
            else Console.WriteLine("nemoguce");
            
        }
    }
}